\section{Kustomize Features}
Kubernetes files are often reused. There are different approaches for reusage: modify the original file to suit your need, make multiple copies and edit them separately for different needs. This bring multiple challenges to takle. Having multiple disparate copies means it is more challenging to leverage a common base set. Making consistent changes across multiple, independent copies for new versions, etc. becomes challenging.

\subsection{Introduction}
Kustomize creates modified Kubernetes manifests by overlaying declarative specifications on top of existing Kubernetes manifests. Changes to make/overlay are stored in a separate file called kustomization.yaml. 
Kustomize reads the kustomization.yaml file and the Kubernetes spec files (manifests) and dumps out completed resources to stdout with the changes from kustomization.yaml applied “on top of” the standard Kubernetes files

\subsubsection{File}
The file is a simple set of declarations which lists the manifest to change (resources) and specifies how to change them (customizations). The actual modification happens with kustomize build.

%todo add sample file

\subsection{Transformers}
Are functions which are built in to Kustomize. These transformers can transform the K8s manifests with simple declarative rules.

\begin{figure}[h!]
  \center
  \includegraphics[width=0.8\textwidth]{transformer}
  \caption{Transformer}
\end{figure}

\subsection{Variants}
Common use case is needing multiple variations (variants) of a set of common resources (i.e. dev, stage, prod).


\subsection{Patches}


